// SerComDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SerCom.h"
#include "ScomDlg.h"
#include "Commtty.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSerComDlg dialog

char *szBaud[] =
{
	"110", "300", "600", "1200", "2400", 
	"4800", "9600", "14400", "19200",
	"38400", "56000", "57600", "115200", 
	"128000", "256000"
};
DWORD BaudTable[] =
{
	CBR_110, CBR_300, CBR_600, CBR_1200, CBR_2400,
	CBR_4800, CBR_9600, CBR_14400, CBR_19200, CBR_38400,
	CBR_56000, CBR_57600, CBR_115200, CBR_128000, CBR_256000
};
char *szDataBits[] = { "5", "6", "7", "8" };
DWORD DataBitsTable[] = { 5, 6, 7, 8 };
char *szParity[] = { "", "", "ż", "", "" };
DWORD ParityTable[] = { NOPARITY, EVENPARITY, ODDPARITY, MARKPARITY, SPACEPARITY };
char *szStopBits[] = { "1", "1.5", "2"  };
DWORD StopBitsTable[] = { ONESTOPBIT, ONE5STOPBITS, TWOSTOPBITS };

CSerComDlg::CSerComDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSerComDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSerComDlg)
	m_gszPort = g_reg.GetProfileString(_T(""), _T("szPort"), _T("COM1"));
	m_bHexShow = g_reg.GetProfileInt(_T(""), _T("bHex"), 1);
	m_data1 = g_reg.GetProfileString(_T(""),_T(KEY1),NULL);
	m_data2 = g_reg.GetProfileString(_T(""),_T(KEY2),NULL);
	m_data3 = g_reg.GetProfileString(_T(""),_T(KEY3),NULL);
	m_data4 = g_reg.GetProfileString(_T(""),_T(KEY4),NULL);
	m_data5 = g_reg.GetProfileString(_T(""),_T(KEY5),NULL);
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	gbHexShow = m_bHexShow;
}

void CSerComDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSerComDlg)
	DDX_CBString(pDX, ID1_COMBO_PORT, m_gszPort);
	DDX_Check(pDX, ID1_CHECK_HEX, m_bHexShow);
	DDX_Text(pDX, ID1_EDIT_DATA1, m_data1);
	DDV_MaxChars(pDX, m_data1, 512);
	DDX_Text(pDX, ID1_EDIT_DATA2, m_data2);
	DDV_MaxChars(pDX, m_data2, 512);
	DDX_Text(pDX, ID1_EDIT_DATA3, m_data3);
	DDV_MaxChars(pDX, m_data3, 512);
	DDX_Text(pDX, ID1_EDIT_DATA4, m_data4);
	DDV_MaxChars(pDX, m_data4, 512);
	DDX_Text(pDX, ID1_EDIT_DATA5, m_data5);
	DDV_MaxChars(pDX, m_data5, 512);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSerComDlg, CDialog)
	//{{AFX_MSG_MAP(CSerComDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CLOSE()
	ON_WM_TIMER()
	ON_BN_CLICKED(ID1_BTN_CONNECT, OnBtnConnect)
	ON_BN_CLICKED(ID1_BTN_DISCONNECT, OnBtnDisconnect)
	ON_BN_CLICKED(ID1_BTN_CLRRECV, OnBtnClearRecv)
	ON_BN_CLICKED(ID1_CHECK_HEX, OnCheckHex)
	ON_BN_CLICKED(ID1_BTN_CLOSE, OnBtnClose)
	ON_EN_CHANGE(ID1_EDIT_DATA1, OnChangeEditData1)
	ON_BN_CLICKED(ID1_BTN_SEND1, OnBtnSend1)
	ON_BN_CLICKED(ID1_BTN_CLR1, OnBtnClr1)
	ON_EN_CHANGE(ID1_EDIT_DATA2, OnChangeEditData2)
	ON_EN_CHANGE(ID1_EDIT_DATA3, OnChangeEditData3)
	ON_EN_CHANGE(ID1_EDIT_DATA4, OnChangeEditData4)
	ON_EN_CHANGE(ID1_EDIT_DATA5, OnChangeEditData5)
	ON_BN_CLICKED(ID1_BTN_CLR2, OnBtnClr2)
	ON_BN_CLICKED(ID1_BTN_CLR3, OnBtnClr3)
	ON_BN_CLICKED(ID1_BTN_CLR4, OnBtnClr4)
	ON_BN_CLICKED(ID1_BTN_CLR5, OnBtnClr5)
	ON_BN_CLICKED(ID1_BTN_SEND2, OnBtnSend2)
	ON_BN_CLICKED(ID1_BTN_SEND3, OnBtnSend3)
	ON_BN_CLICKED(ID1_BTN_SEND4, OnBtnSend4)
	ON_BN_CLICKED(ID1_BTN_SEND5, OnBtnSend5)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

///////////////////////////////////////////////////////////////////////
// غ

BOOL CSerComDlg::Create() 
{
	return CDialog::Create(IDD, NULL);
}

BOOL CSerComDlg::PreTranslateMessage(MSG* pMsg) 
{
	if (pMsg->message==WM_KEYDOWN && pMsg->wParam==VK_RETURN)
	{
		UINT nID = ::GetDlgCtrlID(pMsg->hwnd);
		switch (nID)
		{
		case ID_EDIT_DATA1:
			OnBtnSend1();
			return TRUE;
		case ID_EDIT_DATA2:
			OnBtnSend2();
			return TRUE;
		case ID_EDIT_DATA3:
			OnBtnSend3();
			return TRUE;
		case ID_EDIT_DATA4:
			OnBtnSend4();
			return TRUE;
		case ID_EDIT_DATA5:
			OnBtnSend5();
			return TRUE;
		case ID1_COMBO_PORT:
		case ID1_COMBO_BAUD:
		case ID1_COMBO_DATABITS:
		case ID1_COMBO_PARITY:
		case ID1_COMBO_STOPBITS:
		case ID1_COMBO_FLOW:
		case ID1_CHECK_HEX:
			return TRUE;
		}
	}
	
	return CDialog::PreTranslateMessage(pMsg);
}

BOOL CSerComDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	//ȫھ

	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->EnableMenuItem(pSysMenu->GetMenuItemID(2), MF_GRAYED);
			pSysMenu->EnableMenuItem(pSysMenu->GetMenuItemID(4), MF_GRAYED);
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	//ͼ
	SetIcon(m_hIcon, TRUE);
	SetIcon(m_hIcon, FALSE);

	//ı
	CRect rc;
	GetDlgItem(ID1_STATIC_RECV)->GetWindowRect(&rc);
	ScreenToClient(&rc);
	m_rerecv.Create(WS_VISIBLE|WS_CHILD|WS_BORDER|WS_VSCROLL|ES_LEFT|ES_AUTOVSCROLL|
		ES_READONLY|ES_MULTILINE|ES_WANTRETURN, rc, this, ID1_REDIT_RECV);

	//ʼͨѶ
	InitTTYInfo();

	//ʼͨѶϿ
	CString sBuf;
	for (int i=0; i<MAXPORTS; i++)
	{
		sBuf.Format("COM%d", i+1);
		((CComboBox*)GetDlgItem(ID1_COMBO_PORT))->AddString(sBuf);
    }
    ((CComboBox*)GetDlgItem(ID1_COMBO_PORT))->SetCurSel((PORT(TTYInfo)-1));

    FillComboBox(ID1_COMBO_BAUD,
		  szBaud, BaudTable,
		  sizeof(BaudTable)/sizeof(BaudTable[0]),
		  BAUDRATE(TTYInfo)) ;

    FillComboBox(ID1_COMBO_DATABITS,
		  szDataBits, DataBitsTable,
		  sizeof(DataBitsTable)/sizeof(DataBitsTable[0]),
		  BYTESIZE(TTYInfo)) ;

    FillComboBox(ID1_COMBO_PARITY,
		    szParity, ParityTable,
		    sizeof(ParityTable)/sizeof(ParityTable[0]),
		    PARITY(TTYInfo));

    FillComboBox(ID1_COMBO_STOPBITS,
		    szStopBits, StopBitsTable,
		    sizeof(StopBitsTable)/sizeof(StopBitsTable[0]),
		    STOPBITS(TTYInfo));
	// עжȡԤֵ
	gszPort = g_reg.GetProfileString(_T(""), _T("szPort"), "COM1");
	BAUDRATE(TTYInfo) = g_reg.GetProfileInt(_T(""), _T("Baud"), 19200);
	PARITY(TTYInfo) = (BYTE)g_reg.GetProfileInt(_T(""), _T("Parity"), NOPARITY);
	BYTESIZE(TTYInfo) = (BYTE)g_reg.GetProfileInt(_T(""), _T("Bytes"), 8);
	STOPBITS(TTYInfo) = (BYTE)g_reg.GetProfileInt(_T(""), _T("Stops"), 1);
	// ˢʾ
	ShowCommState();

	//Ӱť״̬
	((CButton*)GetDlgItem(ID1_BTN_CONNECT))->EnableWindow(!CONNECTED(TTYInfo));
	((CButton*)GetDlgItem(ID1_BTN_DISCONNECT))->EnableWindow(CONNECTED(TTYInfo));

	return TRUE;
}

///////////////////////////////////////////////////////////////////////
// Զ庯

void CSerComDlg::FillComboBox(UINT nID, char **str, DWORD *nptab,
							  int tabLen, DWORD dwCurSetting)
{
	CComboBox* pCombo = (CComboBox*)GetDlgItem(nID);
    for (int i=0; i<tabLen; i++)
	{
		int index = pCombo->AddString(str[i]);
		pCombo->SetItemData(index, nptab[i]);
		
		if (nptab[i]==dwCurSetting)
			pCombo->SetCurSel(index);
    }
}

#define GetDlgComboBox(x) ((CComboBox*)GetDlgItem(x))
#define GetDlgComboData(x) (GetDlgComboBox(x)->GetItemData(GetDlgComboBox(x)->GetCurSel()))
void CSerComDlg::UpdateTTYInfo()
{
	UpdateData(TRUE);

	gszPort = m_gszPort;
	g_reg.WriteProfileString(_T(""), _T("szPort"), m_gszPort);
	BAUDRATE(TTYInfo) = GetDlgComboData(ID1_COMBO_BAUD);
	g_reg.WriteProfileInt(_T(""), _T("Baud"), BAUDRATE(TTYInfo));
	PARITY(TTYInfo) = (BYTE)GetDlgComboData(ID1_COMBO_PARITY);
	g_reg.WriteProfileInt(_T(""), _T("Parity"), PARITY(TTYInfo));
	BYTESIZE(TTYInfo) = (BYTE)GetDlgComboData(ID1_COMBO_DATABITS);
	g_reg.WriteProfileInt(_T(""), _T("Bytes"), BYTESIZE(TTYInfo));
	STOPBITS(TTYInfo) = (BYTE)GetDlgComboData(ID1_COMBO_STOPBITS);
	g_reg.WriteProfileInt(_T(""), _T("Stops"), STOPBITS(TTYInfo));
}

void CSerComDlg::SetComboSel(UINT nID, DWORD *nptab, int tabLen, DWORD value)
{
	for (int i=0; i<tabLen; i++)
	{
		if (nptab[i]==value)
		{
			GetDlgComboBox(nID)->SetCurSel(i);
			return;
		}
	}
}

void CSerComDlg::ShowCommState()
{
	((CComboBox*)GetDlgComboBox(ID1_COMBO_PORT))->SelectString(0, gszPort);
	SetComboSel(ID1_COMBO_BAUD,
				BaudTable,
				sizeof(BaudTable)/sizeof(BaudTable[0]),
				BAUDRATE(TTYInfo));
	SetComboSel(ID1_COMBO_PARITY,
				ParityTable,
				sizeof(ParityTable)/sizeof(ParityTable[0]),
				PARITY(TTYInfo));
	SetComboSel(ID1_COMBO_DATABITS,
				DataBitsTable,
				sizeof(DataBitsTable)/sizeof(DataBitsTable[0]),
				BYTESIZE(TTYInfo));
	SetComboSel(ID1_COMBO_STOPBITS,
				StopBitsTable,
				sizeof(StopBitsTable)/sizeof(StopBitsTable[0]),
				STOPBITS(TTYInfo));
}

/////////////////////////////////////////////////////////////////////////////
// CSerComDlg message handlers

void CSerComDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CDialog dlgAbout(IDD_ABOUTBOX);
		dlgAbout.DoModal();
	}
	else if (nID==SC_CLOSE)
		SendMessage(WM_CLOSE, 0, 0); 
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

void CSerComDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CSerComDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CSerComDlg::OnClose() 
{
	KillTimer(1);
	if (CONNECTED(TTYInfo))
		BreakDownCommPort();

	DestroyWindow();
}

void CSerComDlg::OnTimer(UINT nIDEvent) 
{
	if (nIDEvent==1 && CONNECTED(TTYInfo))
	{
		char a = (char)0xaa;
		WriterGeneric(&a, 1);
	}

	CDialog::OnTimer(nIDEvent);
}

///////////////////////////////////////////////////////////////////////
// ԶϢ

void CSerComDlg::OnBtnConnect() 
{
	UpdateTTYInfo();
	//򿪶˿
	if (!SetupCommPort())
		return;
	ShowCommState();
	
	//Ӱť״̬
	((CButton*)GetDlgItem(ID1_BTN_CONNECT))->EnableWindow(!CONNECTED(TTYInfo));
	((CButton*)GetDlgItem(ID1_BTN_DISCONNECT))->EnableWindow(CONNECTED(TTYInfo));
	KillTimer(1);
}

void CSerComDlg::OnBtnDisconnect() 
{
	//رն˿
	BreakDownCommPort();
	//Ӱť״̬
	((CButton*)GetDlgItem(ID1_BTN_CONNECT))->EnableWindow(!CONNECTED(TTYInfo));
	((CButton*)GetDlgItem(ID1_BTN_DISCONNECT))->EnableWindow(CONNECTED(TTYInfo));
}

void CSerComDlg::OnBtnClearRecv() 
{
	m_rerecv.HideSelection(TRUE, TRUE);
	m_rerecv.SetSel(0, m_rerecv.GetTextLength());
	m_rerecv.ReplaceSel("");
}

void CSerComDlg::OnCheckHex() 
{
	UpdateData(TRUE);
	gbHexShow = m_bHexShow;
	g_reg.WriteProfileInt(_T(""), _T("bHex"), m_bHexShow);
}

void CSerComDlg::OnBtnClose() 
{
	SendMessage(WM_CLOSE);
}

BOOL CSerComDlg::SendData(CEdit* pEdit)
{
	//Send  Data
	if (!CONNECTED(TTYInfo))
	{
		::MessageBox(m_hWnd, "ûнӣ", NULL, MB_OK);
		return   FALSE;
	}
	
    UpdateData(); 
	char tbuf[512 + 1], dbuf[512 + 1];
	int tlen = pEdit->GetWindowText(tbuf, 512);

//	AfxMessageBox(tbuf);

	char* p1 = tbuf;
	char* pe = tbuf + tlen;
	int dwData = 0, i=0;
	while (p1<pe)
	{
		while (p1<pe && !isxdigit(*p1)) p1++;
		if (p1>=pe) break;

		char buf[8];
		for (int j=0; p1<pe && j<2 && isxdigit(*p1); p1++)
			buf[j++] = *p1;
		buf[j] = 0;

		// ת16
		BYTE br;
		if (sscanf(buf, _T("%x"), &br)>0)
			dbuf[dwData++] = br;
	}

//	AfxMessageBox(dbuf);
	WriterGeneric(dbuf, dwData);

	return    TRUE;
}

void CSerComDlg::OnChangeEditData1() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	RegData(1);	
}

void CSerComDlg::OnBtnSend1() 
{
	SendData((CEdit*)GetDlgItem(ID_EDIT_DATA1));	
}

void CSerComDlg::OnBtnClr1() 
{
	CEdit*  pEdit = (CEdit*)GetDlgItem(ID_EDIT_DATA1);
	ASSERT_VALID(pEdit);
	pEdit->SetWindowText(_T(""));
}

void CSerComDlg::OnChangeEditData2() 
{
		RegData(2);	
}

void CSerComDlg::OnChangeEditData3() 
{
	RegData(3);
	
}

void CSerComDlg::OnChangeEditData4() 
{
	RegData(4);
	
}

void CSerComDlg::OnChangeEditData5() 
{
	RegData(5);
	
}

void CSerComDlg::OnBtnClr2() 
{
	CEdit*  pEdit = (CEdit*)GetDlgItem(ID_EDIT_DATA2);
	ASSERT_VALID(pEdit);
	pEdit->SetWindowText(_T(""));
}

void CSerComDlg::OnBtnClr3() 
{
	CEdit*  pEdit = (CEdit*)GetDlgItem(ID_EDIT_DATA3);
	ASSERT_VALID(pEdit);
	pEdit->SetWindowText(_T(""));
}

void CSerComDlg::OnBtnClr4() 
{
	CEdit*  pEdit = (CEdit*)GetDlgItem(ID_EDIT_DATA4);
	ASSERT_VALID(pEdit);
	pEdit->SetWindowText(_T(""));
}

void CSerComDlg::OnBtnClr5() 
{
	CEdit*  pEdit = (CEdit*)GetDlgItem(ID_EDIT_DATA5);
	ASSERT_VALID(pEdit);
	pEdit->SetWindowText(_T(""));
}

void CSerComDlg::OnBtnSend2() 
{
	SendData((CEdit*)GetDlgItem(ID_EDIT_DATA2));	
}

void CSerComDlg::OnBtnSend3() 
{
	SendData((CEdit*)GetDlgItem(ID_EDIT_DATA3));	
}

void CSerComDlg::OnBtnSend4() 
{
	SendData((CEdit*)GetDlgItem(ID_EDIT_DATA4));	
}

void CSerComDlg::OnBtnSend5() 
{
	SendData((CEdit*)GetDlgItem(ID_EDIT_DATA5));	
}

void CSerComDlg::RegData(int   index)
{
	CString  key;
	CString  value;
	UpdateData();
	switch(index)
	{
	case   1:   key   = _T(KEY1);
		        value = m_data1;
				break;
	case   2:   key   = _T(KEY2);
		        value = m_data2;
				break;
	case   3:   key   = _T(KEY3);
		        value = m_data3;
				break;
	case   4:   key   = _T(KEY4);
		        value = m_data4;
				break;
	default:    key   = _T(KEY5);
		        value = m_data5;
				break;
	}
	g_reg.WriteProfileString(_T(""), key, value);	
}

